/*
 * listener.c -- a datagram sockets "server" demo
 */
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>

#define MYPORT 4950    /* the port users will be connecting to */

#define MAXBUFLEN 100

int main (void)
{
  struct sockaddr_in my_addr;    /* my address information */
  struct sockaddr_in their_addr; /* connector's address information */
  int    sockfd;
  int    addr_len, numbytes;
  char   buf[MAXBUFLEN];

  if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
  {
    perror ("socket");
    return (1);
  }

  my_addr.sin_family = AF_INET;         /* host byte order */
  my_addr.sin_port = htons(MYPORT);     /* short, network byte order */
  my_addr.sin_addr.s_addr = INADDR_ANY; /* automatically fill with my IP */
  memset (&my_addr.sin_zero,0,8);       /* zero the rest of the struct */

  if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1)
  {
    perror ("bind");
    return (1);
  }

  addr_len = sizeof (struct sockaddr);
  numbytes = recvfrom (sockfd, buf, MAXBUFLEN, 0,
                       (struct sockaddr *)&their_addr, &addr_len);
  if (numbytes < 0)
  {
    perror ("recvfrom");
    return (1);
  }

  printf ("got packet from %s\n",inet_ntoa(their_addr.sin_addr));
  printf ("packet is %d bytes long\n",numbytes);
  buf[numbytes] = '\0';
  printf ("packet contains \"%s\"\n",buf);

  close (sockfd);
  return (0);
}
